package de.slpnetwork.brewcraft.item;

import de.slpnetwork.brewcraft.Brewcraft;
import de.slpnetwork.brewcraft.block.ModBlocks;
import net.minecraft.core.registries.Registries;
import net.minecraft.network.chat.Component;
import net.minecraft.world.item.CreativeModeTab;
import net.minecraft.world.item.ItemStack;
import net.minecraftforge.eventbus.api.IEventBus;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.registries.RegistryObject;

/**
 * used to register Creative Tabs
 */
public class ModCreativeModeTabs {
    public static final DeferredRegister<CreativeModeTab> CREATIVE_MODE_TABS = DeferredRegister.create(Registries.CREATIVE_MODE_TAB, Brewcraft.MODID);

    /**
     * constructs the creative mode tab and adds items to it
     */
    public static final RegistryObject<CreativeModeTab> BREWCRAFT_TAB = CREATIVE_MODE_TABS.register("brewcraft_tab",
            () -> CreativeModeTab.builder().icon(
                    () -> new ItemStack(ModItems.Hop.get()))
                    .title(Component.translatable("creativetab.brewcraft_tab"))
                    .displayItems((pParameters, pOutput) -> {
                        pOutput.accept(ModItems.Saphire.get());
                        pOutput.accept(ModItems.Barley_Malt.get());
                        pOutput.accept(ModItems.Malt.get());
                        pOutput.accept(ModItems.Yeast.get());
                        pOutput.accept(ModItems.Cider_Yeast.get());
                        pOutput.accept(ModItems.Rice.get());
                        pOutput.accept(ModItems.Hop.get());
                        pOutput.accept(ModItems.Grape.get());
                        pOutput.accept(ModItems.Barley.get());
                        pOutput.accept(ModItems.Heater_Body.get());
                        pOutput.accept(ModItems.Heater_Element.get());
                        pOutput.accept(ModItems.Mashine_Body.get());
                        pOutput.accept(ModItems.Milling_Stone.get());
                        pOutput.accept(ModItems.Pressed_Iron.get());
                        pOutput.accept(ModItems.Pressure_Body.get());
                        pOutput.accept(ModItems.Glass.get());
                        pOutput.accept(ModItems.Glass_Of_Whine.get());
                        pOutput.accept(ModItems.Glass_Of_Corn_Beer.get());
                        pOutput.accept(ModItems.Glass_Of_Hop_Beer.get());
                        pOutput.accept(ModItems.Glass_Of_Yeast_Beer.get());
                        pOutput.accept(ModItems.Glass_Of_Pils_Beer.get());
                        pOutput.accept(ModItems.Glass_Of_Apple_Beer.get());
                        pOutput.accept(ModItems.Glass_Of_Apple_Juice.get());
                        pOutput.accept(ModItems.Glass_Of_Grape_Juice.get());
                        pOutput.accept(ModItems.Glass_Of_Water.get());
                        pOutput.accept(ModItems.Glass_Of_Sake.get());
                        pOutput.accept(ModItems.Bottle_Of_Whine.get());
                        pOutput.accept(ModItems.Bottle_Of_Corn_Beer.get());
                        pOutput.accept(ModItems.Bottle_Of_Hop_Beer.get());
                        pOutput.accept(ModItems.Bottle_Of_Yeast_Beer.get());
                        pOutput.accept(ModItems.Bottle_Of_Pils_Beer.get());
                        pOutput.accept(ModItems.Bottle_Of_Apple_Beer.get());
                        pOutput.accept(ModItems.Bottle_Of_Apple_Juice.get());
                        pOutput.accept(ModItems.Bottle_Of_Grape_Juice.get());
                        pOutput.accept(ModItems.Bottle_Of_Sake.get());
                        pOutput.accept(ModBlocks.SAPPHIRE_BLOCK.get());
                    })
                    .build());

    /***
     * registers the deferredregister
     * @param eventBus the mods eventbus
     */
    public static void register(IEventBus eventBus) {
        CREATIVE_MODE_TABS.register(eventBus);
    }
}
